#include <ncurses.h> // on inclue la bibliotheque ncurses
#include <stdlib.h>
#include <string.h>
#include "fonctions.h"
WINDOW *up, *down, *aidebox; // on definie les fenêtre up, down et game
int level;
char faim [50] ; //on definie une variable pour la faim
int compteurfood;
int hp;
int hpmax;
int xp;
int force;
int forcearmemax, forcearmemin;
int positpersox,positpersoy;
int porteo[30];
int porteov[80];
int porteoh[80];
int type[100];
int hpmonstre[100];
int positmonstrex[100],positmonstrey[100];
int marqueurniveau[50];
int compteurfood;
objets objet[500];
liste inventaire[21];
liste coffre[50][10];

void quit (void){
  level = 51;
}

void boite(void) { //on definie une fonction pour afficher les deux booites de base
  up= subwin(stdscr, LINES * 0.8, COLS, 0, 0);        // Créé une fenêtre de 'LINES / 2' lignes et de COLS colonnes en 0, 0
  down= subwin(stdscr, LINES * 0.2, COLS, LINES * 0.8  , 0);
  box(up, ACS_VLINE, ACS_HLINE);
  box(down, ACS_VLINE, ACS_HLINE);
}
void rafraichir(void) { //on definie une fonction pour rafraichir
  wrefresh(up);
  wrefresh(down);
  wrefresh(aidebox);
}
void sauvegarder(char prenom[50],int marqueurs[100]){

  FILE *f;
  int i,j,k;
  int first=1;
  int prenom1;
  char *line = NULL;
  size_t len = 0;
  ssize_t nread;
  /* dossier personnel */
  char buf[255];
  char *home;
  home = getenv("HOME");
  /* création d'une chaîne de caractère avec chemin de fichier */
  sprintf(buf, "%s/.house", home);
  /* test existence du fichier */
  f = fopen(buf, "r");
  if (f!=NULL) {
      first=0;
      fclose(f);
  }
  f = fopen(buf, "w");
  if (f==NULL)
    fprintf(stdout, "Impossible de créer le fichier de sauvegarde.\n");
  else{
    fprintf(f,"nickname=%s\nlevel=%d\npersox%dy%dhp%dhpmax%dxp%dforce%dfood%dmax%dmin%d\n",prenom,level,positpersox,positpersoy,hp,hpmax,xp,force,compteurfood,forcearmemax,forcearmemin);
    for(i=0;i<100;i++){
      fprintf(f,"marqueurs[%d]=%d\n",i,marqueurs[i]);
    }
    for(i=0;i<30;i++){
      fprintf(f,"porteo[%d]=%d\n",i,porteo[i]);
    }
    for(i=0;i<80;i++){
      fprintf(f,"porteov[%d]=%d\n",i,porteov[i]);
    }
    for(i=0;i<80;i++){
      fprintf(f,"porteoh[%d]=%d\n",i,porteoh[i]);
    }
    for(i=0;i<100;i++){
      fprintf(f,"positmonstrex[%d]=%d\n",i,positmonstrex[i]);
    }
    for(i=0;i<100;i++){
      fprintf(f,"positmonstrey[%d]=%d\n",i,positmonstrey[i]);
    }
    for(i=0;i<50;i++){
      fprintf(f,"marqueurniveau[%d]=%d\n",i,marqueurniveau[i]);
    }
    for(i=0;i<100;i++){
      fprintf(f,"type[%d]=%d\n",i,type[i]);
    }
    for(i=0;i<100;i++){
      fprintf(f,"hpmonstre[%d]=%d\n",i,hpmonstre[i]);
    }
    for(i=0;i<500;i++){
      fprintf(f,"objet[%d].hide=%d\n",i,objet[i].hide);
    }
    for(i=0;i<21;i++){
      fprintf(f,"typeinventaire[%d]=%d\n",i,inventaire[i].type);
    }
    for(i=0;i<21;i++){
      fprintf(f,"idinventaire[%d]=%d\n",i,inventaire[i].id);
    }
    for(i=0;i<21;i++){
      fprintf(f,"invidinventaire[%d]=%c\n",i,inventaire[i].invid);
    }
    for(i=0;i<10;i++){
      fprintf(f,"snameinv[%d]=%s\n",i,inventaire[i].name);
    }
    for(i=10;i<21;i++){
      fprintf(f,"lnameinv[%d]=%s\n",i,inventaire[i].name);
    }
    for(i=0;i<21;i++){
      fprintf(f,"useinventaire[%d]=%d\n",i,inventaire[i].use);
    }
    for(i=0;i<10;i++){
      fprintf(f,"snameobjet[%d]=%s\n",i,objet[i].name);
    }
    for(i=10;i<100;i++){
      fprintf(f,"lnameobjet[%d]=%s\n",i,objet[i].name);
    }
    for(i=100;i<500;i++){
      fprintf(f,"bnameobjet[%d]=%s\n",i,objet[i].name);
    }
    for(i=0;i<21;i++){
      for(j=0;j<21;j++){
        fprintf(f,"parainv[%d][%d]=%d\n",i,j,inventaire[i].parametre[j]);
      }
    }
    for(i=0;i<21;i++){
      for(j=0;j<500;j++){
        fprintf(f,"usecoffre[%d][%d]=%d\n",j,i,coffre[objet[j].parametre[0]][i].use);
      }
    }
    fclose(f);
  }

}
void load(char *prenom,int marqueurs[100]){

  FILE *f;
  int i,j,n;
  int l=0;
  int ll=0;
  int k=10;
  int kk=10;
  int m=100;
  int first=1;
  char debug[512];
  int tempo;
  char tempochar;
  char tempocharr[250];
  int marqueur[50];
  char *line = NULL;
  size_t len = 0;
  ssize_t nread;
  /* dossier personnel */
  char buf[255];
  char *home;
  home = getenv("HOME");
  /* création d'une chaîne de caractère avec chemin de fichier */
  sprintf(buf, "%s/.house", home);
  /* test existence du fichier */

  f = fopen(buf, "r");
  while ((nread = getline(&line, &len, f)) != -1) {
    marqueur[0]=strncmp(line,"nickname=",9);
    if (marqueur[0]==0){
        strncpy(prenom, line + 9, nread-10);
        prenom[nread-10] = '\0';
    }
    marqueur[1]=strncmp(line,"level=",6);
    if (marqueur[1]==0)
      sscanf(line,"level=%d\n",&level);
    marqueur[2]=strncmp(line,"persox",6);
    if (marqueur[2]==0)
      sscanf(line,"persox%dy%dhp%dhpmax%dxp%dforce%dfood%dmax%dmin%d\n",&positpersox,&positpersoy,&hp,&hpmax,&xp,&force,&compteurfood,&forcearmemax,&forcearmemin);
    marqueur[3]=strncmp(line,"marqueurs[",10);
    if (marqueur[3]==0){
      sscanf(line,"marqueurs[%d]=%d\n",&i,&tempo);
      marqueurs[i]=tempo;
    }
    marqueur[4]=strncmp(line,"porteo[",7);
    if (marqueur[4]==0){
      sscanf(line,"porteo[%d]=%d\n",&i,&tempo);
      porteo[i]=tempo;
    }
    marqueur[5]=strncmp(line,"porteov[",8);
    if (marqueur[5]==0){
      sscanf(line,"porteov[%d]=%d\n",&i,&tempo);
      porteov[i]=tempo;
    }
    marqueur[6]=strncmp(line,"porteoh[",8);
    if (marqueur[6]==0){
      sscanf(line,"porteoh[%d]=%d\n",&i,&tempo);
      porteoh[i]=tempo;
    }
    marqueur[7]=strncmp(line,"positmonstrex[",14);
    if (marqueur[7]==0){
      sscanf(line,"positmonstrex[%d]=%d\n",&i,&tempo);
      positmonstrex[i]=tempo;
    }
    marqueur[8]=strncmp(line,"positmonstrey[",14);
    if (marqueur[8]==0){
      sscanf(line,"positmonstrey[%d]=%d\n",&i,&tempo);
      positmonstrey[i]=tempo;
    }
    marqueur[9]=strncmp(line,"marqueurniveau[",15);
    if (marqueur[9]==0){
      sscanf(line,"marqueurniveau[%d]=%d\n",&i,&tempo);
      marqueurniveau[i]=tempo;
    }
    marqueur[10]=strncmp(line,"type[",5);
    if (marqueur[10]==0){
      sscanf(line,"type[%d]=%d\n",&i,&tempo);
      type[i]=tempo;
    }
    marqueur[11]=strncmp(line,"hpmonstre[",10);
    if (marqueur[11]==0){
      sscanf(line,"hpmonstre[%d]=%d\n",&i,&tempo);
      hpmonstre[i]=tempo;
    }
    marqueur[12]=strncmp(line,"objet[",6);
    if (marqueur[12]==0){
      sscanf(line,"objet[%d].hide=%d\n",&i,&tempo);
      objet[i].hide=tempo;
    }
    marqueur[13]=strncmp(line,"typeinventaire[",15);
    if (marqueur[13]==0){
      sscanf(line,"typeinventaire[%d]=%d\n",&i,&tempo);
      inventaire[i].type=tempo;
    }
    marqueur[14]=strncmp(line,"idinventaire[",13);
    if (marqueur[14]==0){
      sscanf(line,"idinventaire[%d]=%d\n",&i,&tempo);
      inventaire[i].id=tempo;
    }
    marqueur[15]=strncmp(line,"invidinventaire[",16);
    if (marqueur[15]==0){
      sscanf(line,"invidinventaire[%d]=%c\n",&i,&tempochar);
      inventaire[i].invid=tempochar;
    }
    marqueur[16]=strncmp(line,"snameinv[",9);
    if (marqueur[16]==0){
        strncpy(tempocharr, line + 12, nread-13);
        sprintf (inventaire[l].name,"%s", tempocharr);
        inventaire[l].name[nread-13] = '\0';
        l++;
    }
    marqueur[17]=strncmp(line,"lnameinv[",9);
    if (marqueur[17]==0){
        strncpy(tempocharr, line + 13, nread-14);
        sprintf (inventaire[k].name,"%s", tempocharr);
        inventaire[k].name[nread-14] = '\0';
        k++;
    }
    marqueur[18]=strncmp(line,"useinventaire[",14);
    if (marqueur[18]==0){
      sscanf(line,"useinventaire[%d]=%d\n",&i,&tempo);
      inventaire[i].use=tempo;
    }
    marqueur[19]=strncmp(line,"snameobjet[",11);
    if (marqueur[19]==0){
        strncpy(tempocharr, line + 14, nread-15);
        sprintf (objet[ll].name,"%s", tempocharr);
        objet[ll].name[nread-15] = '\0';
        ll++;
    }
    marqueur[20]=strncmp(line,"lnameobjet[",11);
    if (marqueur[20]==0){
        strncpy(tempocharr, line + 15, nread-16);
        sprintf (objet[kk].name,"%s", tempocharr);
        objet[kk].name[nread-16] = '\0';
        kk++;
    }
    marqueur[21]=strncmp(line,"bnameobjet[",11);
    if (marqueur[21]==0){
        strncpy(tempocharr, line + 16, nread-17);
        sprintf (objet[m].name,"%s", tempocharr);
        objet[m].name[nread-17] = '\0';
        m++;
    }
    marqueur[22]=strncmp(line,"parainv[",8);
    if (marqueur[22]==0){
      sscanf(line,"parainv[%d][%d]=%d\n",&i,&j,&tempo);
      inventaire[i].parametre[j]=tempo;
    }
    marqueur[23]=strncmp(line,"usecoffre[",10);
    if (marqueur[23]==0){
      sscanf(line,"usecoffre[%d][%d]=%d\n",&j,&i,&tempo);
      coffre[objet[j].parametre[0]][i].use=tempo;
    }
  }
  fclose(f);

}
void food (void){

  if(compteurfood >= 180 && compteurfood <= 250){
    strcpy(faim,"rassasie");
    if(hp<hpmax){
	hp++;
    }
  }
  if(compteurfood >= 135 && compteurfood <= 180){
    strcpy(faim,"un peu faim");
  }
  if(compteurfood >= 100 && compteurfood <= 135){
    strcpy(faim,"faim");
  }
  if(compteurfood >= 75 && compteurfood <= 100){
    strcpy(faim,"beaucoup faim");
  }
  if(compteurfood >= 15 && compteurfood <= 75){
    strcpy(faim,"si je mange pas je meurs");
  }
  if(compteurfood <= 15){
    strcpy(faim,"je meurs");
    //hp -= 7;
  }

}
void xpcompteur (void){
  if (xp>=20){
    force =4;
    hpmax = 150;
  }
  if (xp>=50){
    force =5;
    hpmax = 175;
  }
  if (xp>=100){
    force =5;
    hpmax = 190;
  }
}
